include file.e
include get.e
include graphics.e
include machine.e
include wildcard.e

without warning

crash_message("\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" &
"Dark Frontend has performed an illegal operation and will be shut down...\n" &
"and it's all MY FAULT =P.  Please send the DFRNTEND.ERR file to my e-mail\n" &
"at mzzt@thegaminguniverse.com, along with a description of what you were\n" &
"doing when Dark Frontend 'sploded.  If you know how to, also attaching the\n" &
"DFRNTEND.INI file and a directory tree of your DARK dir and subdirs would\n" &
"be most helpful.\n\nHAVE A NICE DAY!!!\n\n" &
"(Er, and I'm sorry for the inconvenience.)\n")
crash_file("DFRNTEND.ERR")

global constant Verbose = 0,
-- Change this to 1 to enable debugging.
		VideoMem = #B8000,
-- You can change to #B0000 for monochrome monitors... but I don't know why
-- you would, since DF only runs on 8-bit color. :)
		Executable = "DFRNTEND.EX",
-- The main DFRNTEND.EX file name.  Used to vertify LEVELS dir.  Is a constant
-- so if it's ever compiled into an EXE, it can be changed easily.
		FALSE = 0,
		TRUE = not FALSE,
		GameName = 1,
		GOBName = 2,
		LFDName = 3,
		CRAWLName = 4,
		Others = 5
		
global sequence DarkDir, LFDDir, LevelsDir
DarkDir = "C:\\DARK"
LFDDir = "C:\\DARK\\LFD"
LevelsDir = "C:\\DARK\\LEVELS"

global type bool(integer x)
    return(x = TRUE or x = FALSE)
end type

global sequence Wallpaper, PaperFile
PaperFile = "DFRNTEND.SRN"

global function trim(sequence Text)
    for i = 1 to length(Text) do
	if Text[i] != 32 then
	    for j = length(Text) to 1 by -1 do
		if Text[i] != 32 then
		    return(Text[i..j])
		end if
	    end for
	    return(Text[i..length(Text)])
	end if
    end for
    return(Text)
end function

global function LoadSRN(sequence filename)
    integer fn
    sequence woohoo, stuff
    fn = open(filename, "rb")
    
    if fn = -1 then
	return({0})
    end if
    
    woohoo = {getc(fn), getc(fn), getc(fn)}
    if compare(woohoo, "GOD") then
	return({0})
    end if

    stuff = {}
    for i = 1 to (80 * 25) do
	woohoo = {getc(fn), getc(fn)}
	stuff &= woohoo[2]
	stuff &= woohoo[1]
    end for

    close(fn)

    return(stuff)
end function

global procedure Center(sequence Text, integer c3, integer c2, integer c1)
    sequence temp
    temp = get_position()

    position(temp[1], floor((80 - length(Text)) / 2) + 1)
    if length(Text) >= 4 then
	text_color(c1)
	puts(2, Text[1])
	text_color(c2)
	puts(2, Text[2])
	text_color(c3)
	puts(2, Text[3..length(Text) - 2])
	text_color(c2)
	puts(2, Text[length(Text) - 1])
	text_color(c1)
	puts(2, Text[length(Text)])
    else
	text_color(c3)
	puts(2, Text)
    end if
end procedure

global function INIExist(integer fn, sequence Section, sequence Key)
    object temp
    sequence temp2

    if seek(fn, 0) then end if
    temp = {}
    while compare(trim(upper(temp)), "[" & upper(Section) & "]") do
	temp = gets(fn)
	if not compare(temp, -1) then
	    return(0)
	end if
	while length(temp) > 0 and (not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10)) do
	    
	    temp = temp[1..length(temp) - 1]
	end while
    end while
    if not compare(Key, "") then
	return(1)   -- INIExist is being used to check for existance of section.
    end if
    while 1 do
	temp = gets(fn)
	if not compare(temp, -1) then
	    return(0)
	else
	    temp2 = trim(temp)
	    if not compare(temp2[1], "[") then
		return(0)
	    end if
	end if
	while length(temp) > 0 and (not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10)) do
	    
	    temp = temp[1..length(temp) - 1]
	end while
	if find('=', temp) and not compare(trim(upper(temp[1..find('=', temp)
	    - 1])), upper(Key)) then

	    return(1)
	end if
    end while
end function

integer INIseekpos
sequence INIsection
INIseekpos = 0
INIsection = ""
global function MasterINIExist(integer fn, sequence Section, sequence Key)
    object temp, temp3
    sequence temp2
    temp = {}
    
    if seek(fn, INIseekpos) then end if
    if compare(INIsection, Section) or INIseekpos = 0 then
	INIsection = Section
	for i = 1 to 2 do
	    if i = 2 then
		if seek(fn, 0) then end if
	    end if
	    temp = {}
	    temp3 = 0
	    while temp3 = 0 and compare(trim(upper(temp)), "[" & upper(Section) & "]") do
		temp = gets(fn)
		if not compare(temp, -1) then
		    if i = 1 then
			temp3 = 1
			exit
		    end if
		    return(0)
		end if
		while length(temp) > 0 and (not compare(temp[length(temp)], 13)
		    or not compare(temp[length(temp)], 10)) do
		    
		    temp = temp[1..length(temp) - 1]
		end while
	    end while
	end for
    end if
	
    if not compare(Key, "") then
	return(1)   -- INIExist is being used to check for existance of section.
    end if
    while 1 do
	temp = gets(fn)
	if not compare(temp, -1) then
	    return(0)
	else
	    temp2 = trim(temp)
	    if not compare(temp2[1], "[") then
		return(0)
	    end if
	end if
	while length(temp) > 0 and (not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10)) do
	    
	    temp = temp[1..length(temp) - 1]
	end while
	if find('=', temp) and not compare(trim(upper(temp[1..find('=', temp)
	    - 1])), upper(Key)) then

	    return(1)
	end if
    end while
end function

global function MasterINIRead(integer fn, sequence Section, sequence Key)
    object temp, temp3
    sequence temp2
    temp = {}
    
    if seek(fn, INIseekpos) then end if
    if compare(INIsection, Section) or INIseekpos = 0 then
	INIsection = Section
	for i = 1 to 2 do
	    if i = 2 then
		if seek(fn, 0) then end if
	    end if
	    temp = {}
	    temp3 = 0
	    while temp3 = 0 and compare(trim(upper(temp)), "[" & upper(Section) & "]") do
		temp = gets(fn)
		if not compare(temp, -1) then
		    if i = 1 then
			temp3 = 1
			exit
		    end if
		    if Verbose then
			text_color(12)
			printf(2, "Could not find section %s in INI!\n", {Section})
			text_color(7)
			puts(2, "Press any key to continue...\n")
			while get_key() = -1 do end while
		    end if
		    return("")
		end if
		while length(temp) > 0 and (not compare(temp[length(temp)], 13)
		    or not compare(temp[length(temp)], 10)) do
		
		    temp = temp[1..length(temp) - 1]
		end while
	    end while
	    INIseekpos = where(fn)
	end for
    end if
    while 1 do
	temp = gets(fn)
	if not compare(temp, -1) then
	    if Verbose then
		text_color(12)
		printf(2, "Could not find section %s, key %s in INI! (EOF)\n",
		    {Section, Key})
		text_color(7)
		puts(2, "Press any key to continue...\n")
		while get_key() = -1 do end while
	    end if
	    return("")
	else
	    temp2 = trim(temp)
	    if not compare(temp2[1], "[") then
		if Verbose then
		    text_color(12)
		    printf(2, "Could not find section %s, key %s in INI! (End "
			& "of section)\n", {Section, Key})
			text_color(7)
		    puts(2, "Press any key to continue...\n")
		    while get_key() = -1 do end while
		end if
		return("")
	    end if
	end if
	while length(temp) > 0 and (not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10)) do
	
	    temp = temp[1..length(temp) - 1]
	end while
	if find('=', temp) and not compare(trim(upper(temp[1..find('=', temp)
	    - 1])), upper(Key)) then

	    temp2 = trim(temp)
	    while not compare(temp2[length(temp2)], 13)
		or not compare(temp2[length(temp2)], 10) do

		temp2 = temp2[1..length(temp2) - 1]
	    end while
	    return(temp2[find('=', temp2) + 1..length(temp)])
	end if
    end while
end function

global function INIRead(integer fn, sequence Section, sequence Key)
    object temp
    sequence temp2
    temp = {}
    
    if seek(fn, 0) then end if
    while compare(trim(upper(temp)), "[" & upper(Section) & "]") do
	temp = gets(fn)
	if not compare(temp, -1) then
	    if Verbose then
		text_color(12)
		printf(2, "Could not find section %s in INI!\n", {Section})
		text_color(7)
		puts(2, "Press any key to continue...\n")
		while get_key() = -1 do end while
	    end if
	    return("")
	end if
	while length(temp) > 0 and (not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10)) do
	    
	    temp = temp[1..length(temp) - 1]
	end while
    end while
    while 1 do
	temp = gets(fn)
	if not compare(temp, -1) then
	    if Verbose then
		text_color(12)
		printf(2, "Could not find section %s, key %s in INI! (EOF)\n",
		    {Section, Key})
		text_color(7)
		puts(2, "Press any key to continue...\n")
		while get_key() = -1 do end while
	    end if
	    return("")
	else
	    temp2 = trim(temp)
	    if not compare(temp2[1], "[") then
		if Verbose then
		    text_color(12)
		    printf(2, "Could not find section %s, key %s in INI! (End "
			& "of section)\n", {Section, Key})
			text_color(7)
		    puts(2, "Press any key to continue...\n")
		    while get_key() = -1 do end while
		end if
		return("")
	    end if
	end if
	while length(temp) > 0 and (not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10)) do
	
	    temp = temp[1..length(temp) - 1]
	end while
	if find('=', temp) and not compare(trim(upper(temp[1..find('=', temp)
	    - 1])), upper(Key)) then

	    temp2 = trim(temp)
	    while not compare(temp2[length(temp2)], 13)
		or not compare(temp2[length(temp2)], 10) do

		temp2 = temp2[1..length(temp2) - 1]
	    end while
	    return(temp2[find('=', temp2) + 1..length(temp)])
	end if
    end while
end function

-- Taken from Euphoria's INSTALL.EX
global function exist(sequence path)
-- check if file or directory exists
    return(sequence(dir(path)))
end function

--My old exist() function... not as good as the one above.
--global function exist(sequence filename)
    --integer fn
    --
    --fn = open(filename, "rb")
    --if fn = -1 then
	--return(FALSE)
    --else
	--close(fn)
	--return(TRUE)
    --end if
--end function

procedure DoShadow(integer x, integer y, integer num)
    integer wow, hmm

    for i = 0 to num - 1 do
	wow = peek(VideoMem + (160 * (y - 1)) + (2 * (x - 1 + i)) + 1)
	if wow >= 128 then
	    wow -= 128
	else
	    while wow >= 16 do
		wow -= 16
	    end while
	end if
	if wow >= 8 and wow <= 15 then
	    wow -= 8
	else
	    hmm = wow
	    while hmm >= 16 do
		hmm -= 16
	    end while
	    wow -= hmm
	end if
	poke(VideoMem + (160 * (y - 1)) + (2 * (x - 1 + i)) + 1, wow)
    end for
end procedure

function ForeColor(integer C)
    return remainder(C, 16)
end function

function BackColor(integer C)
    return floor(C / 16)
end function

function ColorOf(integer c1, integer c2)
    return (c2 * 16) + c1
end function

procedure XPrint(sequence Text, integer Color, integer x, integer y)
    -- Stub for my XPrint routine.  I don't really need it.
    position(y, x)
    text_color(ForeColor(Color))
    bk_color(BackColor(Color))
    puts(2, Text)
end procedure

global procedure DrawWindow(sequence C, integer x, integer y, integer x2,
    integer y2, integer NumLines)
    -- C = {Background, Inside Foreground, Border Colors 1, 2, 3, 4, 5, 6}
    -- NumLines = 1 or 2
    
    sequence Box
    
    if NumLines = 2 then
	Box = "ͻȼ"
    else
	Box = "Ŀ"
    end if
    
    XPrint({Box[1]} & repeat(Box[2], x2 - x - 2), ColorOf(C[3], C[1]), x, y)
    XPrint({Box[2]}, ColorOf(C[4], C[1]), x2 - 1, y)
    XPrint({Box[3]}, ColorOf(C[5], C[1]), x2, y)
    for i = y + 1 to y2 - 2 do
	XPrint({Box[4]}, ColorOf(C[3], C[1]), x, i)
	XPrint(repeat(' ', x2 - x - 1), ColorOf(C[2], C[1]), x + 1, i)
	XPrint({Box[4]}, ColorOf(C[6], C[1]), x2, i)
	DoShadow(x2 + 1, i, 2)
    end for
    XPrint({Box[4]}, ColorOf(C[4], C[1]), x, y2 - 1)
    XPrint(repeat(' ', x2 - x - 1), ColorOf(C[2], C[1]), x + 1, y2 - 1)
    XPrint({Box[4]}, ColorOf(C[7], C[1]), x2, y2 - 1)
    DoShadow(x2 + 1, y2 - 1, 2)
    XPrint({Box[5]}, ColorOf(C[5], C[1]), x, y2)
    XPrint(repeat(Box[2], x2 - x - 2), ColorOf(C[6], C[1]), x + 1, y2)
    XPrint({Box[2]}, ColorOf(C[7], C[1]), x2 - 1, y2)
    XPrint({Box[6]}, ColorOf(C[8], C[1]), x2, y2)
    DoShadow(x2 + 1, y2, 2)
    DoShadow(x + 2, y2 + 1, x2 - x + 1)
end procedure

global procedure MakeWindow(integer x1, integer y1, integer x2, integer y2,
    integer c1, integer c2)

    DrawWindow({1, 15, 15, 11, 3, 9, 1, 0}, x1, y1, x2, y2, 2)
end procedure

global function SaveScreen()
    sequence temp, temp2

    temp = peek({VideoMem, 4000})
    temp2 = get_position()

    return({temp, temp2})
end function

global procedure RestoreScreen(sequence screen)
    poke(VideoMem, screen[1])
    position(screen[2][1], screen[2][2])
end procedure

global procedure DrawWallpaper(integer firstrowdraw)
    if firstrowdraw = FALSE then
	poke(VideoMem + 160, Wallpaper[161..length(Wallpaper)])
    else
	poke(VideoMem, Wallpaper)
    end if
end procedure

global function LimitInput(sequence value, integer x1, integer y1, integer x2,
    bool UCase)
    
    integer Key, Offset, Pos
    sequence String
    Offset = 1
    String = value
    Pos = length(String) + 1

    position(y1, x1)
    if length(String) > x2 - x1 then
	printf(2, "%s",
	    {String[length(String) - (x2 - x1 - 1)..length(String)]})
	Offset = length(String) - (x2 - x1 - 1)
	position(y1, x1 - Offset + Pos)
    else
	printf(2, "%s", {String & repeat(' ', (x2 - x1 + 1) - length(String))})
	position(y1, x1 + Pos - 1)
    end if
    cursor(UNDERLINE_CURSOR)
    while 1 do
	Key = -1
	while Key = -1 do
	    Key = get_key()
	end while
	if UCase then
	    Key = upper(Key)
	end if
	if Key >= 32 and Key <= 254 then
	    String = String[1..Pos - 1] & Key & String[Pos..length(String)]
	    Pos += 1
	elsif Key = 331 and Pos > 1 then
	    Pos -= 1
	elsif Key = 333 and Pos < length(String) + 1 then
	    Pos += 1
	    if Pos > Offset + (x2 - x1) then
		Offset += 1
	    end if
	elsif Key = 8 and Pos > 1 then
	    String = String[1..Pos - 2] & String[Pos..length(String)]
	    Pos -= 1
	    if Offset > 1 then
		Offset -= 1
	    end if
	elsif Key = 339 and Pos < length(String) + 1 then
	    String = String[1..Pos - 1] & String[Pos + 1..length(String)]
	elsif Key = 327 then
	    Pos = 1
	elsif Key = 335 then
	    Pos = length(String) + 1
	elsif Key = 13 then
	    position(y1, x1)
	    if x2 - x1 + 1 > length(String) then
		printf(2, "%s",
		    {String & repeat(' ', x2 - x1 + 1 - length(String))})
	    else
		printf(2, "%s", {String[1..x2 - x1 + 1]})
	    end if
	    cursor(NO_CURSOR)
	    return(String)
	elsif Key = 27 then
	    position(y1, x1)
	    if x2 - x1 + 1 > length(value) then
		printf(2, "%s",
		    {value & repeat(' ', x2 - x1 + 1 - length(value))})
	    else
		printf(2, "%s", {value[1..x2 - x1 + 1]})
	    end if
	    cursor(NO_CURSOR)
	    return(value)
	end if
	position(y1, x1)
	if Pos < Offset then
	    Offset = Pos
	end if
	if Pos > Offset + (x2 - x1) then
	    Offset = Pos - (x2 - x1)
	end if
	if length(String) < x2 - x1 + 1 then
	    Offset = 1
	end if
	if Offset + (x2 - x1) > length(String) then
	    printf(2, "%s",
		{String[Offset..length(String)] &
		repeat(' ', Offset + (x2 - x1) - length(String))})
	else
	    printf(2, "%s",
		{String[Offset..Offset + (x2 - x1)]})
	end if
	position(y1, x1 - Offset + Pos)
    end while
end function

global function replace(sequence OldSource, sequence Source, sequence Target)
    integer temp
    temp = match(OldSource, Target)
    if temp then
	return(Target[1..temp - 1] & Source &
	    Target[temp + length(OldSource)..length(Target)])
    else
	return(Target)
    end if
end function

global procedure DrawOpStuff()
    bk_color(0)
    if exist(DarkDir & "\\DARK.EXE") then
	text_color(2)
    else
	text_color(4)
    end if
    position(6, 25)
    if length(DarkDir) < 30 then
	printf(2, "%s",
	    {DarkDir & repeat(' ', 30 - length(DarkDir))})
    else
	printf(2, "%s", {DarkDir[1..30]})
    end if
    if exist(LFDDir & "\\DFBRIEF.LFD") and
	exist(LFDDir & "\\FTEXTCRA.LFD") then
	
	text_color(2)
    else
	text_color(4)
    end if
    position(9, 25)
    if length(LFDDir) < 30 then
	printf(2, "%s",
	    {LFDDir & repeat(' ', 30 - length(LFDDir))})
    else
	printf(2, "%s", {LFDDir[1..30]})
    end if
    if exist(LevelsDir & "\\" & Executable) then
	text_color(2)
    else
	text_color(4)
    end if
    position(12, 25)
    if length(LevelsDir) < 30 then
	printf(2, "%s",
	    {LevelsDir & repeat(' ', 30 - length(LevelsDir))})
    else
	printf(2, "%s", {LevelsDir[1..30]})
    end if
    if exist(LevelsDir & "\\" & PaperFile) then
	text_color(2)
    else
	text_color(4)
    end if
    position(15, 25)
    if length(PaperFile) < 30 then
	printf(2, "%s",
	    {PaperFile & repeat(' ', 30 - length(PaperFile))})
    else
	printf(2, "%s", {PaperFile[1..30]})
    end if
    text_color(0)
    bk_color(1)
    position(18, 34)
    puts(2, "͸")
    position(19, 34)
    puts(2, "           ")
    text_color(10)
    position(19, 36)
    puts(2, 17 & "       " & 16)
    text_color(15)
    position(19, 38)
    puts(2, "Close")
    text_color(0)
    position(20, 34)
    puts(2, ";")
end procedure

global procedure WriteFile()
    integer fn
    fn = open("DFRNTEND.INI", "wb")
    printf(fn, "[Main]\nDarkDir=%s\nLFDDir=%s\nLevelsDir=%s\nWallpaper=%s",
	{DarkDir, LFDDir, LevelsDir, PaperFile})
    close(fn)
end procedure

global procedure Options()
    integer i, Key
    sequence temp

    MakeWindow(23, 4, 56, 21, 15, 1)
    text_color(14)
    bk_color(1)
    position(5, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "DARK FORCES DIRECTORY")
    text_color(14)
    puts(2, " >Ŀ")
    position(6, 24)
    puts(2, "                              ")
    position(7, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(6, 25)
    puts(2, "                              ")
    text_color(14)
    bk_color(1)
    position(8, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "DARK FORCES LFD DIRECTORY")
    text_color(14)
    puts(2, " >Ŀ")
    position(9, 24)
    puts(2, "                              ")
    position(10, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(9, 25)
    puts(2, "                              ")
    text_color(14)
    bk_color(1)
    position(11, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "ADD-ON LEVELS DIRECTORY")
    text_color(14)
    puts(2, " >Ŀ")
    position(12, 24)
    puts(2, "                              ")
    position(13, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(12, 25)
    puts(2, "                              ")
    text_color(14)
    bk_color(1)
    position(14, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "WALLPAPER FILE")
    text_color(14)
    puts(2, " >Ŀ")
    position(15, 24)
    puts(2, "                              ")
    position(16, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(15, 25)
    puts(2, "                              ")
    DrawOpStuff()
    i = 0
    while 1 do
	if i = 0 then
	    bk_color(0)
	    if exist(DarkDir & "\\DARK.EXE") then
		text_color(10)
	    else
		text_color(12)
	    end if
	    position(6, 25)
	    if length(DarkDir) < 30 then
		printf(2, "%s",
		    {DarkDir & repeat(' ', 30 - length(DarkDir))})
	    else
		printf(2, "%s", {DarkDir[1..30]})
	    end if
	elsif i = 1 then
	    bk_color(0)
	    if exist(LFDDir & "\\DFBRIEF.LFD") and
		exist(LFDDir & "\\FTEXTCRA.LFD") then
		
		text_color(10)
	    else
		text_color(12)
	    end if
	    position(9, 25)
	    if length(LFDDir) < 30 then
		printf(2, "%s",
		    {LFDDir & repeat(' ', 30 - length(LFDDir))})
	    else
		printf(2, "%s", {LFDDir[1..30]})
	    end if
	elsif i = 2 then
	    bk_color(0)
	    if exist(LevelsDir & "\\" & Executable) then
		text_color(10)
	    else
		text_color(12)
	    end if
	    position(12, 25)
	    if length(LevelsDir) < 30 then
		printf(2, "%s",
		    {LevelsDir & repeat(' ', 30 - length(LevelsDir))})
	    else
		printf(2, "%s", {LevelsDir[1..30]})
	    end if
	elsif i = 3 then
	    bk_color(0)
	    if exist(LevelsDir & "\\" & PaperFile) then
		text_color(10)
	    else
		text_color(12)
	    end if
	    position(15, 25)
	    if length(PaperFile) < 30 then
		printf(2, "%s",
		    {PaperFile & repeat(' ', 30 - length(PaperFile))})
	    else
		printf(2, "%s", {PaperFile[1..30]})
	    end if
	elsif i = 4 then
	    text_color(14)
	    bk_color(1)
	    position(18, 34)
	    puts(2, "͸")
	    position(19, 34)
	    puts(2, "           ")
	    text_color(10)
	    position(19, 36)
	    puts(2, 17 & "       " & 16)
	    text_color(15)
	    position(19, 38)
	    puts(2, "CLOSE")
	    text_color(14)
	    position(20, 34)
	    puts(2, ";")
	end if
	Key = -1
	while Key = -1 do
	    Key = get_key()
	end while
	if Key = 328 then
	    i -= 1
	    if i = -1 then
		i = 4
	    end if
	    DrawOpStuff()
	elsif Key = 336 then
	    i += 1
	    if i = 5 then
		i = 0
	    end if
	    DrawOpStuff()
	elsif Key = 27 then
	    WriteFile()
	    return
	elsif Key = 13 or Key = 32 then
	    if i = 4 then
		WriteFile()
		return
	    elsif i = 3 then
		text_color(15)
		bk_color(0)
		PaperFile = LimitInput(PaperFile, 25, 15, 54, TRUE)
		if exist(LevelsDir & "\\" & PaperFile) then
		    text_color(10)
		else
		    text_color(12)
		end if
		position(15, 25)
		if length(PaperFile) < 30 then
		    printf(2, "%s",
			{PaperFile & repeat(' ', 30 - length(PaperFile))})
		else
		    printf(2, "%s", {PaperFile[1..30]})
		end if
	    elsif i = 2 then
		text_color(15)
		bk_color(0)
		LevelsDir = LimitInput(LevelsDir, 25, 12, 54, TRUE)
		if LevelsDir[length(LevelsDir)] = '\\' then
		    LevelsDir = LevelsDir[1..length(LevelsDir) - 1]
		end if
		if exist(LevelsDir & "\\" & Executable) then
		    text_color(10)
		else
		    text_color(12)
		end if
		position(12, 25)
		if length(LevelsDir) < 30 then
		    printf(2, "%s",
			{LevelsDir & repeat(' ', 30 - length(LevelsDir))})
		else
		    printf(2, "%s", {LevelsDir[1..30]})
		end if
		if exist(LevelsDir & "\\" & PaperFile) then
		    text_color(2)
		else
		    text_color(4)
		end if
		position(15, 25)
		if length(PaperFile) < 30 then
		    printf(2, "%s",
			{PaperFile & repeat(' ', 30 - length(PaperFile))})
		else
		    printf(2, "%s", {PaperFile[1..30]})
		end if
	    elsif i = 1 then
		text_color(15)
		bk_color(0)
		LFDDir = LimitInput(LFDDir, 25, 9, 54, TRUE)
		if LFDDir[length(LFDDir)] = '\\' then
		    LFDDir = LFDDir[1..length(LFDDir) - 1]
		end if
		if exist(LFDDir & "\\DFBRIEF.LFD") and
		    exist(LFDDir & "\\FTEXTCRA.LFD") then
		    
		    text_color(10)
		else
		    text_color(12)
		end if
		position(9, 25)
		if length(LFDDir) < 30 then
		    printf(2, "%s",
			{LFDDir & repeat(' ', 30 - length(LFDDir))})
		else
		    printf(2, "%s", {LFDDir[1..30]})
		end if
	    elsif i = 0 then
		text_color(15)
		bk_color(0)
		temp = DarkDir
		DarkDir = LimitInput(DarkDir, 25, 6, 54, TRUE)
		if DarkDir[length(DarkDir)] = '\\' then
		    DarkDir = DarkDir[1..length(DarkDir) - 1]
		end if
		if exist(DarkDir & "\\DARK.EXE") then
		    text_color(10)
		else
		    text_color(12)
		end if
		position(6, 25)
		if length(DarkDir) < 30 then
		    printf(2, "%s",
			{DarkDir & repeat(' ', 30 - length(DarkDir))})
		else
		    printf(2, "%s", {DarkDir[1..30]})
		end if
		text_color(7)
		LFDDir = replace(temp, DarkDir, LFDDir)
		if exist(LFDDir & "\\DFBRIEF.LFD") and
		    exist(LFDDir & "\\FTEXTCRA.LFD") then
		    
		    text_color(2)
		else
		    text_color(4)
		end if
		position(9, 25)
		if length(LFDDir) < 30 then
		    printf(2, "%s",
			{LFDDir & repeat(' ', 30 - length(LFDDir))})
		else
		    printf(2, "%s", {LFDDir[1..30]})
		end if
		LevelsDir = replace(temp, DarkDir, LevelsDir)
		if exist(LevelsDir & "\\" & Executable) then
		    text_color(2)
		else
		    text_color(4)
		end if
		position(12, 25)
		if length(LevelsDir) < 30 then
		    printf(2, "%s",
			{LevelsDir & repeat(' ', 30 - length(LevelsDir))})
		else
		    printf(2, "%s", {LevelsDir[1..30]})
		end if
		if exist(LevelsDir & "\\" & PaperFile) then
		    text_color(2)
		else
		    text_color(4)
		end if
		position(15, 25)
		if length(PaperFile) < 30 then
		    printf(2, "%s",
			{PaperFile & repeat(' ', 30 - length(PaperFile))})
		else
		    printf(2, "%s", {PaperFile[1..30]})
		end if
	    end if
	end if
    end while
end procedure

global function StartsAt(integer fn, sequence Section, sequence KeyRoot)
    integer temp
    temp = INIExist(fn, Section, KeyRoot & "0")
    if temp then
	return(0)
    end if
    temp = INIExist(fn, Section , KeyRoot & "1")
    if temp then
	return(1)
    end if
    return(-1)
end function

global procedure run(sequence dothis, integer code)
    if Verbose then
	puts(2, "> " & dothis & "\n")
    end if
    system(dothis, code)
end procedure

global function run_prog(sequence dothis, integer code)
    if Verbose then
	puts(2, "> " & dothis & "\n")
    end if
    return(system_exec(dothis, code))
end function
